//=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
//                    This source created by dlg2src
//                    Target: C++/TCLib
//=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
#include <windows.h>
#define   x64

#pragma warning(disable: 4312) // remove warning C4312: 'type cast': conversion from 'long' to 'HMENU' of greater size
#pragma warning(disable: 4267) // remove warning C4267: conversion from 'size_t' to 'int', possible loss of data
#pragma warning(disable: 4244) // remove warning C4244: conversion from 'ssize_t' to 'int', possible loss of data

#include "..\TCLib\stdio.h"
#include "..\TCLib\string.h"
#include "..\TCLib\stdlib.h"
#include "..\TCLib\memory.h"
#include "..\TCLib\malloc.h"
#include "..\TCLib\math.h"
#include "..\TCLib\tchar.h"
#include "..\TCLib\Strings.cpp"
#include <commctrl.h>
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"advapi32.lib")

#pragma warning(disable: 4312) // remove warning C4312: 'type cast': conversion from 'long' to 'HMENU' of greater size

//==============================================================================
void Center_Win (HWND hwnd)
{
    RECT     WndRect = {0};
    long     x = {0};
    long     y = {0};
    GetWindowRect(hwnd, &WndRect);
    x = ( GetSystemMetrics( SM_CXSCREEN) - ( WndRect.right - WndRect.left)) / 2;
    y = ( GetSystemMetrics( SM_CYSCREEN) - ( WndRect.bottom - WndRect.top + GetSystemMetrics( SM_CYCAPTION))) / 2;
    SetWindowPos(hwnd, NULL, x, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}
//==============================================================================
HFONT Create_Font (const _TCHAR* szFaceName, long lPointSize)
{
    LOGFONT  tlf = {0};
    HDC      hdc = {0};
    hdc = GetDC( HWND_DESKTOP);
    tlf.lfHeight = - MulDiv( lPointSize, GetDeviceCaps( hdc, LOGPIXELSY), 72);
    tlf.lfWidth = 0;
    tlf.lfEscapement = 0;
    tlf.lfOrientation = 0;
    tlf.lfWeight = 0;
    tlf.lfItalic = 0;
    tlf.lfUnderline = 0;
    tlf.lfStrikeOut = 0;
    tlf.lfCharSet = ANSI_CHARSET;
    tlf.lfOutPrecision = OUT_TT_PRECIS;
    tlf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    tlf.lfQuality = DEFAULT_QUALITY;
    tlf.lfPitchAndFamily = FF_DONTCARE;
    _tcscpy(tlf.lfFaceName, szFaceName);
    ReleaseDC(HWND_DESKTOP, hdc);
    return (HFONT)CreateFontIndirect( &tlf);
}

HWND AddLabel(IN HWND hParent, IN DWORD dwStyle, IN WCHAR* sLabel, IN int x, IN int y, IN int w, IN int h, IN int nID, IN HFONT hFont) {
    HWND hCtl = CreateWindowEx(0, L"Static", sLabel, dwStyle, x, y, w, h, hParent, (HMENU) nID, GetModuleHandle(NULL), NULL);
    if (dwStyle == 0) { dwStyle = 0x50000000; }
    SendMessage(hCtl, WM_SETFONT, (WPARAM) hFont, (LPARAM) 0);
    return hCtl;
}

HWND AddEdit(IN HWND hParent, IN WCHAR* sLabel, IN int x, IN int y, IN int w, IN int h, IN int nID, IN HFONT hFont) {
    HWND hCtl = CreateWindowEx(0x00000200, L"Edit", sLabel, 0x50010000, x, y, w, h, hParent, (HMENU) nID, GetModuleHandle(NULL), NULL);
    SendMessage(hCtl, WM_SETFONT, (WPARAM) hFont, (LPARAM) 0);
    return hCtl;
}

HWND AddButton(IN HWND hParent, IN WCHAR* sLabel, IN int x, IN int y, IN int w, IN long h, IN int nID, IN HFONT hFont) {
    HWND hCtl = CreateWindowEx(0, L"Button", sLabel, 0x50010000, x, y, w, h, hParent, (HMENU) nID, GetModuleHandle(NULL), NULL);
    SendMessage(hCtl, WM_SETFONT, (WPARAM) hFont, (LPARAM) 0);
    return hCtl;
}

//==============================================================================
void SetClientSize (HWND hwnd, long nWidth, int nHeight)
{
    RECT     rc = {0};
    RECT     rcTemp = {0};
    SetRect( &rc, 0, 0, nWidth, nHeight);
    HANDLE   hMenu = GetMenu(hwnd);
    DWORD    dwStyle = (DWORD) GetWindowLongPtr(hwnd, GWL_STYLE);
    AdjustWindowRectEx( &rc, dwStyle, (hMenu != NULL), (DWORD) GetWindowLongPtr(hwnd, GWL_EXSTYLE));
    if(hMenu != NULL )
    {
        rcTemp = rc;
        rcTemp.bottom = 0x7FFF;
        SendMessage(hwnd, (UINT)WM_NCCALCSIZE, (WPARAM)0, (LPARAM)&rcTemp);
        rc.bottom +=   rcTemp.top;
    }
    if((dwStyle & WS_HSCROLL) == WS_HSCROLL )
    {
        rc.bottom = rc.bottom + GetSystemMetrics( SM_CYHSCROLL);
    }
    if((dwStyle & WS_VSCROLL) == WS_VSCROLL )
    {
        rc.right = rc.right + GetSystemMetrics( SM_CXVSCROLL);
    }
    long     cx = rc.right - rc.left;
    long     cy = rc.bottom - rc.top;
    SetWindowPos(hwnd, NULL, 0, 0, cx, cy, SWP_NOZORDER | SWP_NOMOVE | SWP_NOACTIVATE);
}
//==============================================================================
#define IDD_DLG1  1000
#define IDC_INDEX1  1001
#define IDC_INDEX2  1002
#define IDC_COMPANY1  1003
#define IDC_COMPANY2  1004
#define IDC_FIRST  1005
#define IDC_FIRSTNAME  1006
#define IDC_LAST  1007
#define IDC_LASTNAME  1008
#define IDC_ADDRESS1  1009
#define IDC_ADDRESS2  1010
#define IDC_CITY1  1011
#define IDC_CITY2  1012
#define IDC_COUNTY  1034
#define IDC_COUNTY2  1013
#define IDC_STATE1  1014
#define IDC_STATE2  1015
#define IDC_ZIP1  1016
#define IDC_ZIP2  1017
#define IDC_PHONE11  1018
#define IDC_PHONE12  1019
#define IDC_PHONE21  1020
#define IDC_PHONE22  1021
#define IDC_EMAIL1  1022
#define IDC_EMAIL2  1023
#define IDC_URL1  1024
#define IDC_URL2  1025
#define IDC_PRIOR  1026
#define IDC_NEXT  1027
#define IDC_FIND  1028
#define IDC_ADD  1029
#define IDC_UPDATE  1030
#define IDC_DELETE  1031
#define IDC_PRINT  1032
#define IDC_CLOSE  1033

//==============================================================================
LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM  wParam, LPARAM  lParam)
{
    switch(Msg)
    {
    case WM_COMMAND:
        if(LOWORD(wParam) == IDCANCEL && HIWORD(wParam) == BN_CLICKED )
        {
            SendMessage(hWnd, (UINT)WM_CLOSE, (WPARAM)0, (LPARAM)0);
        }
        break;
    case WM_DESTROY:
        PostQuitMessage(0);
        break;
    }
    return DefWindowProc(hWnd, Msg, wParam, lParam);
}
//==============================================================================
int WINAPI _tWinMain (HINSTANCE  hInst, HINSTANCE  hPrev, LPWSTR  CmdLine, int CmdShow)
{
    HWND     hWin = {0};
    HWND     hCtl = {0};
    WNDCLASSEX  wcx = {0};
    MSG      uMsg = {0};
    HFONT    hFont = {0};
    _TCHAR     szClassName[] = L"SdkWindow";
    INITCOMMONCONTROLSEX  icc = {0};
    icc.dwSize = sizeof( icc);
    icc.dwICC = ICC_NATIVEFNTCTL_CLASS | ICC_COOL_CLASSES | ICC_BAR_CLASSES | ICC_TAB_CLASSES | ICC_USEREX_CLASSES | ICC_WIN95_CLASSES | ICC_STANDARD_CLASSES | ICC_ANIMATE_CLASS | ICC_DATE_CLASSES | ICC_HOTKEY_CLASS | ICC_INTERNET_CLASSES | ICC_LISTVIEW_CLASSES | ICC_PAGESCROLLER_CLASS | ICC_PROGRESS_CLASS | ICC_TREEVIEW_CLASSES | ICC_UPDOWN_CLASS;
    InitCommonControlsEx( &icc);
    wcx.cbSize = sizeof( wcx);
    wcx.style = CS_HREDRAW | CS_VREDRAW;
    wcx.lpfnWndProc = WndProc;
    wcx.cbClsExtra = 0;
    wcx.cbWndExtra = 0;
    wcx.hInstance = hInst;
    wcx.hIcon = LoadIcon( NULL, IDI_APPLICATION);
    wcx.hCursor = LoadCursor( NULL, IDC_ARROW);
    wcx.hbrBackground = ( HBRUSH)( COLOR_BTNFACE + 1);
    wcx.lpszMenuName = 0;
    wcx.lpszClassName = szClassName;
    wcx.hIconSm = LoadIcon( NULL, IDI_APPLICATION);
    if(!RegisterClassEx( &wcx))
    {
        MessageBox (GetActiveWindow(), L"RegisterClassEx Failed", L"", 0 );
         return 0;
    }
    hFont = Create_Font(L"Tahoma",10);
    DWORD dwStyle = WS_POPUP | WS_CAPTION | WS_SYSMENU |WS_MINIMIZEBOX;
    hWin = CreateWindowEx(0,szClassName, L"Address Book",dwStyle, 0, 0 ,0, 0, 0, 0,hInst,NULL);
    SetClientSize(hWin, 445, 490);

    hCtl = AddLabel(hWin, 0, L"Record No.", 275, 10, 89, 16, IDC_INDEX1, hFont);
    hCtl = AddLabel(hWin, 0x50001201, L"0  /  0", 361, 8, 70, 20, IDC_INDEX2, hFont);
    hCtl = AddLabel(hWin, 0, L"Company", 9, 48, 105, 16, IDC_COMPANY1, hFont);
    hCtl =  AddEdit(hWin, L"", 119, 44, 263, 24, IDC_COMPANY2, hFont);
    hCtl =  AddLabel(hWin, 0, L"First Name", 9, 76, 105, 16, IDC_FIRST, hFont);
    hCtl =  AddEdit(hWin, L"", 119, 72, 263, 24, IDC_FIRSTNAME, hFont);
    hCtl =  AddLabel(hWin, 0, L"Last Name", 9, 104, 105, 16, IDC_LAST, hFont);
    hCtl =  AddEdit(hWin, L"", 119,100,263,24, IDC_LASTNAME, hFont);
    hCtl =  AddLabel(hWin, 0, L"Address", 9, 132, 105, 16, IDC_ADDRESS1, hFont);
    hCtl =  AddEdit(hWin, L"", 119,128,263,24, IDC_ADDRESS2, hFont);
    hCtl =  AddLabel(hWin, 0, L"City", 9, 160, 105, 16, IDC_CITY1, hFont);
    hCtl =  AddEdit(hWin, L"", 119,156,263,24, IDC_CITY2, hFont);
    hCtl =  AddLabel(hWin, 0, L"County", 9, 188, 105, 16, IDC_COUNTY, hFont);
    hCtl =  AddEdit(hWin, L"", 119,184,263,24, IDC_COUNTY2, hFont);
    hCtl =  AddLabel(hWin, 0, L"State", 9, 216, 105, 16, IDC_STATE1, hFont);
    hCtl =  AddEdit(hWin, L"", 119,212,51,24, IDC_STATE2, hFont);
    hCtl =  AddLabel(hWin, 0, L"Zip", 9, 244, 105, 16, IDC_ZIP1, hFont);
    hCtl =  AddEdit(hWin, L"", 119,240,100,24, IDC_ZIP2, hFont);
    hCtl =  AddLabel(hWin, 0, L"Phone #1", 9, 272, 105, 16, IDC_PHONE11, hFont);
    hCtl =  AddEdit(hWin, L"", 119, 268, 121, 24, IDC_PHONE12, hFont);
    hCtl =  AddLabel(hWin, 0, L"Phone #2", 9, 300, 105, 16, IDC_PHONE21, hFont);
    hCtl =  AddEdit(hWin, L"", 119, 296, 121, 24, IDC_PHONE22, hFont);
    hCtl =  AddLabel(hWin, 0, L"Email", 9, 328, 105, 16, IDC_EMAIL1, hFont);
    hCtl =  AddEdit(hWin, L"", 119, 324, 263, 24, IDC_EMAIL2, hFont);
    hCtl =  AddLabel(hWin, 0, L"WWW", 9,356,105,16, IDC_URL1, hFont);
    hCtl =  AddEdit(hWin, L"", 119,352,263,24, IDC_URL2, hFont);

    hCtl =  AddButton(hWin, L"<< Prior", 46, 406, 70, 28, IDC_PRIOR, hFont);
    hCtl =  AddButton(hWin, L"Next >>", 140, 406, 70, 28, IDC_NEXT, hFont);
    hCtl =  AddButton(hWin, L"Find", 235, 406, 70, 28, IDC_FIND, hFont);
    hCtl =  AddButton(hWin, L"Add", 331, 406, 70, 28, IDC_ADD, hFont);
    hCtl =  AddButton(hWin, L"Update", 46, 442, 70, 28, IDC_UPDATE, hFont);
    hCtl =  AddButton(hWin, L"Delete", 140, 442, 70, 28, IDC_DELETE, hFont);
    hCtl =  AddButton(hWin, L"Print", 235, 442, 70 ,28, IDC_PRINT, hFont);
    hCtl =  AddButton(hWin, L"Close", 331, 442, 70, 28, IDC_CLOSE, hFont);

    Center_Win(hWin);

    ShowWindow(hWin,SW_SHOW);

    while (GetMessage( &uMsg, NULL, 0, 0)) {
        if (IsDialogMessage(hWin, &uMsg)) {
            continue;
        }
        TranslateMessage( &uMsg);
        DispatchMessage( &uMsg);
    }
    return (int) uMsg.wParam;
}
